---
- name: "Stop reverse logical replication (Source cluster <-- Target cluster)"
  hosts: 'source_cluster:target_cluster'
  gather_facts: true
  become: true
  become_user: "{{ os_pg_user }}"
  any_errors_fatal: true
  vars:
    non_interactive: false  # if 'true', no confirmation will be requested before performing the switchver.
  tasks:
    - name: '[Prepare] Get Patroni Cluster Leader Node'
      uri:
        url: http://{{ inventory_hostname }}:{{ patroni_restapi_port }}/leader
        status_code: 200
      register: patroni_leader_result
      changed_when: false
      failed_when: false
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])
      tags: always

    - name: '[Prepare] Set the variable: patroni_cluster_leader: true'
      set_fact:
        patroni_cluster_leader: true
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])
        - patroni_leader_result.status == 200
      tags: always

    - name: '[Prepare] Set the variable: patroni_cluster_leader: false'
      set_fact:
        patroni_cluster_leader: false
      when:
        - (inventory_hostname in groups['source_cluster'] or
           inventory_hostname in groups['target_cluster'])
        - patroni_leader_result.status != 200
      tags: always

    # Request confirmation (if 'non_interactive' is 'false')
    - block:
        - name: Stop reverse logical replication?
          pause:
            prompt: "Are you sure you want to stop reverse logical replication? [y/N]"
          delegate_to: "{{ groups['source_cluster'][0] }}"
          register: prompt_result

        - name: "Set the variable: ask_result"
          set_fact:
            ask_result: "{{ hostvars[groups['source_cluster'][0]]['prompt_result']['user_input'] }}"
      when:
        - not non_interactive | bool

    # Stop reverse logical replication
    - name: "(SOURCE) Stop reverse logical replication"
      include_role:
        name: upgrade
        tasks_from: drop_subscription
      vars:
        dbname: "{{ pg_source_dbname }}"
        subscription_name: "{{ pg_source_subscription_name }}"
        pg_publication_count: "{{ pg_publication_count_reverse }}"
      when:
        - enable_reverse_logical_replication | bool
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
        - (ask_result is defined and ask_result == "y" or non_interactive != 'false')

    - name: "(TARGET) Clean up reverse logical replication objects on the target cluster"
      include_role:
        name: upgrade
        tasks_from: drop_publication
      vars:
        dbname: "{{ pg_target_dbname }}"
        publication_name: "{{ pg_target_publication_name }}"
        logical_slot_name: "{{ pg_target_logical_slot_name }}"
        pg_publication_count: "{{ pg_publication_count_reverse }}"
      when:
        - enable_reverse_logical_replication | bool
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
        - (ask_result is defined and ask_result == "y" or non_interactive != 'false')

...
